Index: branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.api/src/main/java/org/gvsig/fmap/dal/raster/RasterStore.java
===================================================================
--- branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.api/src/main/java/org/gvsig/fmap/dal/raster/RasterStore.java	(revision 0)
+++ branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.api/src/main/java/org/gvsig/fmap/dal/raster/RasterStore.java	(revision 43876)
@@ -0,0 +1,191 @@
+/* gvSIG. Desktop Geographic Information System.
+ *
+ * Copyright © 2007-2016 gvSIG Association
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License
+ * as published by the Free Software Foundation; either version 2
+ * of the License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
+ * MA  02110-1301, USA.
+ *
+ * For any additional information, do not hesitate to contact us
+ * at info AT gvsig.com, or visit our website www.gvsig.com.
+ */
+package org.gvsig.fmap.dal.raster;
+
+import java.util.List;
+
+import org.gvsig.fmap.dal.DataStore;
+import org.gvsig.fmap.dal.DataStoreParameters;
+import org.gvsig.fmap.dal.exception.DataException;
+import org.gvsig.fmap.dal.exception.InitializeException;
+import org.gvsig.fmap.geom.exception.CreateEnvelopeException;
+import org.gvsig.fmap.geom.primitive.Envelope;
+import org.gvsig.raster.lib.buffer.api.BandInfo;
+import org.gvsig.raster.lib.buffer.api.BufferDimensions;
+import org.gvsig.tools.dynobject.DynObject;
+import org.gvsig.tools.lang.Cloneable;
+import org.gvsig.tools.locator.LocatorException;
+import org.gvsig.tools.observer.Observer;
+
+/**
+ * Store for rasters
+ * @author dmartinezizquierdo
+ *
+ */
+public interface RasterStore extends DataStore, Cloneable{
+
+    /**
+     * May provide a dynamic method to get the legend
+     */
+    final public static String DYNMETHOD_GETLEGEND_NAME = "getLegend";
+
+    /**
+     * May provide a dynamic method to get the Color Interpretation
+     */
+    final public static String DYNMETHOD_GETCOLORINTERPRETATION_NAME = "getColorInterpretation";
+
+    /**
+     * May provide a dynamic method to get the Color Table
+     */
+    final public static String DYNMETHOD_GETCOLORTABLE_NAME = "getColorTable";
+    /**
+     * Returns this store's parameters.
+     *
+     * @return
+     *         {@link DataStoreParameters} containing this store's parameters
+     */
+    public DataStoreParameters getParameters();
+
+    /**
+     * Returns all available data in the store
+     * @return RasterSet
+     * @throws DataException
+     */
+    RasterSet getRasterSet() throws DataException;
+
+    /**
+     * Returns a subset of data taking into account the properties and
+     * restrictions of the RasterQuery.
+     * @param rasterQuery
+     * @param RasterQuery
+     * @return RasterSet
+     * @throws DataException
+     */
+    RasterSet getRasterSet(RasterQuery rasterQuery) throws DataException;
+
+    /**
+     * Returns a new {@link RasterQuery} associated to this store.
+     * @return RasterQuery
+     */
+    RasterQuery createRasterQuery();
+
+    /**
+     * Returns the envelope associated to this store buffer
+     * @return Envelope
+     * @throws DataException
+     * @throws CreateEnvelopeException
+     * @throws LocatorException
+     */
+    Envelope getEnvelope() throws DataException, LocatorException, CreateEnvelopeException;
+
+    /**
+     * Creates a {@link BandQuery} from band received as parameter.
+     *
+     * @param band
+     *            Band to create BandQuery
+     * @return BandQuery
+     */
+    public BandQuery createBandQuery(int band);
+
+    /**
+     * Gets {@link BandsDescriptor} of band received as parameter. If band does
+     * not have {@link BandDescriptor}, this method will return an
+     * empty {@link BandsDescriptor}.
+     *
+     * @param band
+     *            Band to get its {@link BandsDescriptor}
+     * @return BandDescriptor
+     */
+    public BandDescriptor getBandDescriptor(int band);
+
+    /**
+     * Gets number of total bands
+     *
+     * @return Number of bands
+     */
+    public int getBands();
+
+    public List<BandDescriptor> getBandDescriptors();
+
+    /**
+     * @return
+     */
+    public RasterCache getCache();
+
+    /**
+     * Add a band from other store.
+     * If the store is the same of main store will return a IllegalAttributeException
+     *
+     * @param store
+     * @param band
+     * @throws DataException
+     */
+    public void addBand(RasterStore store, int band) throws DataException;
+
+    /**
+     * Add a list of bands from other store.
+     * If the store is the same of main store will return a IllegalAttributeException
+     *
+     * @param store
+     * @param bands
+     * @throws DataException
+     */
+    public void addBands(RasterStore store, List<Integer> bands) throws DataException;
+
+    /**
+     * Remove a band.
+     * If band belongs to main store, will return a IllegalAttributeException
+     *
+     * @param band
+     */
+    public void removeBand(int band);
+
+    /**
+     * Remove any band that does not belong to itself.
+     */
+    public void clearAdditionalBands();
+
+    /**
+     * Return true if the band is own. If the band is from additional store, return false.
+     *
+     * @param band
+     * @return
+     */
+    public boolean isOwnBand(int band);
+
+    /**
+     * Return the buffer dimensions of the complete store.
+     * @return
+     * @throws InitializeException
+     */
+    public BufferDimensions getDimensions() throws InitializeException;
+
+    public boolean isTiled();
+
+    void getRasterSet(Observer observer) throws DataException;
+
+    void getRasterSet(RasterQuery dataQuery, Observer observer) throws DataException;
+
+
+
+}
Index: branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.api/src/main/java/org/gvsig/fmap/dal/raster/RasterKernel.java
===================================================================
--- branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.api/src/main/java/org/gvsig/fmap/dal/raster/RasterKernel.java	(revision 0)
+++ branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.api/src/main/java/org/gvsig/fmap/dal/raster/RasterKernel.java	(revision 43876)
@@ -0,0 +1,63 @@
+/* gvSIG. Desktop Geographic Information System.
+ *
+ * Copyright © 2007-2016 gvSIG Association
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License
+ * as published by the Free Software Foundation; either version 2
+ * of the License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
+ * MA  02110-1301, USA.
+ *
+ * For any additional information, do not hesitate to contact us
+ * at info AT gvsig.com, or visit our website www.gvsig.com.
+ */
+
+package org.gvsig.fmap.dal.raster;
+
+/**
+ * Info given by the raster in a selected row and column
+ * @author dmartinezizquierdo
+ *
+ */
+public interface RasterKernel   {
+
+    /**
+     * Number of bands from the raster
+     * @return int
+     */
+    public int getBandCount();
+
+    /**
+     * Raster row which is being informed
+     * @return row
+     */
+    public int getRow();
+
+    /**
+     * Raster column which is being informed
+     * @return column
+     */
+    public int getColumn();
+
+    /**
+     * Values of the bands in the row and column given
+     * @return Object[]
+     */
+    public Object[] getValue();
+
+    /**
+     * A 3x3 matrix around the row and column given with the values of the bands
+     * @return Object[][][]
+     */
+    public Object[][][] getValues();
+
+}
Index: branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.api/src/main/java/org/gvsig/fmap/dal/raster/exceptions/RasterQueryCloneException.java
===================================================================
--- branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.api/src/main/java/org/gvsig/fmap/dal/raster/exceptions/RasterQueryCloneException.java	(revision 0)
+++ branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.api/src/main/java/org/gvsig/fmap/dal/raster/exceptions/RasterQueryCloneException.java	(revision 43876)
@@ -0,0 +1,55 @@
+/* gvSIG. Desktop Geographic Information System.
+ *
+ * Copyright © 2007-2016 gvSIG Association
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License
+ * as published by the Free Software Foundation; either version 2
+ * of the License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
+ * MA  02110-1301, USA.
+ *
+ * For any additional information, do not hesitate to contact us
+ * at info AT gvsig.com, or visit our website www.gvsig.com.
+ */
+package org.gvsig.fmap.dal.raster.exceptions;
+
+import org.gvsig.fmap.dal.exception.DataException;
+import org.gvsig.fmap.dal.raster.RasterQuery;
+
+
+/**
+ * Exception thrown when an error is produced while cloning a
+ * {@link RasterQuery}.
+ *
+ */
+public class RasterQueryCloneException extends DataException {
+
+    /**
+     *
+     */
+    private static final long serialVersionUID = -5083976241813494957L;
+
+    private final static String MESSAGE_FORMAT =
+            "Error cloning a RasterQuery";
+    private final static String MESSAGE_KEY = "_RasterQueryCloneException";
+
+    /**
+     * Creates a new {@link RasterQueryCloneException}.
+     *
+     * @param cause
+     *            the original cause of the exception
+     */
+    public RasterQueryCloneException(Throwable cause) {
+        super(MESSAGE_FORMAT, cause, MESSAGE_KEY, serialVersionUID);
+    }
+
+}
\ No newline at end of file
Index: branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.api/src/main/java/org/gvsig/fmap/dal/raster/exceptions/RasterSetInitializeException.java
===================================================================
--- branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.api/src/main/java/org/gvsig/fmap/dal/raster/exceptions/RasterSetInitializeException.java	(revision 0)
+++ branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.api/src/main/java/org/gvsig/fmap/dal/raster/exceptions/RasterSetInitializeException.java	(revision 43876)
@@ -0,0 +1,54 @@
+/* gvSIG. Desktop Geographic Information System.
+ *
+ * Copyright © 2007-2016 gvSIG Association
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License
+ * as published by the Free Software Foundation; either version 2
+ * of the License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
+ * MA  02110-1301, USA.
+ *
+ * For any additional information, do not hesitate to contact us
+ * at info AT gvsig.com, or visit our website www.gvsig.com.
+ */
+package org.gvsig.fmap.dal.raster.exceptions;
+
+import org.gvsig.fmap.dal.exception.DataException;
+import org.gvsig.fmap.dal.feature.FeatureSet;
+
+
+/**
+ * Exception thrown when an error is produced while creating or initializing a
+ * {@link FeatureSet}.
+ *
+ */
+public class RasterSetInitializeException extends DataException {
+
+    /**
+     *
+     */
+    private static final long serialVersionUID = -2549348802998322067L;
+    private final static String MESSAGE_FORMAT =
+            "Error initializing a RasterSet";
+    private final static String MESSAGE_KEY = "_RasterSetInitializeException";
+
+    /**
+     * Creates a new {@link RasterSetInitializeException}.
+     *
+     * @param cause
+     *            the original cause of the exception
+     */
+    public RasterSetInitializeException(Throwable cause) {
+        super(MESSAGE_FORMAT, cause, MESSAGE_KEY, serialVersionUID);
+    }
+
+}
\ No newline at end of file
Index: branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.spi/src/main/java/org/gvsig/fmap/dal/raster/spi/AbstractRasterStoreProvider.java
===================================================================
--- branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.spi/src/main/java/org/gvsig/fmap/dal/raster/spi/AbstractRasterStoreProvider.java	(revision 43875)
+++ branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.spi/src/main/java/org/gvsig/fmap/dal/raster/spi/AbstractRasterStoreProvider.java	(revision 43876)
@@ -36,10 +36,10 @@
 import org.gvsig.fmap.dal.exception.CloseException;
 import org.gvsig.fmap.dal.exception.InitializeException;
 import org.gvsig.fmap.dal.exception.OpenException;
-import org.gvsig.fmap.dal.raster.api.BandAttributeDescriptor;
-import org.gvsig.fmap.dal.raster.api.BandDescriptor;
-import org.gvsig.fmap.dal.raster.api.BandQuery;
-import org.gvsig.fmap.dal.raster.api.RasterQuery;
+import org.gvsig.fmap.dal.raster.BandAttributeDescriptor;
+import org.gvsig.fmap.dal.raster.BandDescriptor;
+import org.gvsig.fmap.dal.raster.BandQuery;
+import org.gvsig.fmap.dal.raster.RasterQuery;
 import org.gvsig.fmap.dal.resource.ResourceManager;
 import org.gvsig.fmap.dal.resource.spi.ResourceManagerProviderServices;
 import org.gvsig.fmap.dal.resource.spi.ResourceProvider;
Index: branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.spi/src/main/java/org/gvsig/fmap/dal/raster/spi/RasterCacheStoreProvider.java
===================================================================
--- branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.spi/src/main/java/org/gvsig/fmap/dal/raster/spi/RasterCacheStoreProvider.java	(revision 43875)
+++ branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.spi/src/main/java/org/gvsig/fmap/dal/raster/spi/RasterCacheStoreProvider.java	(revision 43876)
@@ -25,9 +25,9 @@
 import org.cresques.cts.IProjection;
 
 import org.gvsig.fmap.dal.exception.DataException;
-import org.gvsig.fmap.dal.raster.api.RasterCache;
-import org.gvsig.fmap.dal.raster.api.RasterQuery;
-import org.gvsig.fmap.dal.raster.api.RasterStore;
+import org.gvsig.fmap.dal.raster.RasterCache;
+import org.gvsig.fmap.dal.raster.RasterQuery;
+import org.gvsig.fmap.dal.raster.RasterStore;
 
 
 /**
Index: branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.spi/src/main/java/org/gvsig/fmap/dal/raster/spi/RasterStoreProviderServices.java
===================================================================
--- branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.spi/src/main/java/org/gvsig/fmap/dal/raster/spi/RasterStoreProviderServices.java	(revision 43875)
+++ branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.spi/src/main/java/org/gvsig/fmap/dal/raster/spi/RasterStoreProviderServices.java	(revision 43876)
@@ -25,9 +25,9 @@
 import java.util.List;
 
 import org.gvsig.fmap.dal.DataManager;
-import org.gvsig.fmap.dal.raster.api.BandAttributeDescriptor;
-import org.gvsig.fmap.dal.raster.api.BandDescriptor;
-import org.gvsig.fmap.dal.raster.api.RasterStore;
+import org.gvsig.fmap.dal.raster.BandAttributeDescriptor;
+import org.gvsig.fmap.dal.raster.BandDescriptor;
+import org.gvsig.fmap.dal.raster.RasterStore;
 import org.gvsig.fmap.dal.resource.Resource;
 import org.gvsig.fmap.dal.resource.spi.ResourceProvider;
 import org.gvsig.fmap.dal.spi.DataStoreProviderServices;
Index: branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.spi/src/main/java/org/gvsig/fmap/dal/raster/spi/BandDescriptorServices.java
===================================================================
--- branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.spi/src/main/java/org/gvsig/fmap/dal/raster/spi/BandDescriptorServices.java	(revision 43875)
+++ branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.spi/src/main/java/org/gvsig/fmap/dal/raster/spi/BandDescriptorServices.java	(revision 43876)
@@ -1,7 +1,7 @@
 package org.gvsig.fmap.dal.raster.spi;
 
-import org.gvsig.fmap.dal.raster.api.BandAttributeDescriptor;
-import org.gvsig.fmap.dal.raster.api.BandDescriptor;
+import org.gvsig.fmap.dal.raster.BandAttributeDescriptor;
+import org.gvsig.fmap.dal.raster.BandDescriptor;
 
 
 public interface BandDescriptorServices extends BandDescriptor {
Index: branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.spi/src/main/java/org/gvsig/fmap/dal/raster/spi/AbstractAwtRasterStoreProvider.java
===================================================================
--- branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.spi/src/main/java/org/gvsig/fmap/dal/raster/spi/AbstractAwtRasterStoreProvider.java	(revision 43875)
+++ branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.spi/src/main/java/org/gvsig/fmap/dal/raster/spi/AbstractAwtRasterStoreProvider.java	(revision 43876)
@@ -16,8 +16,8 @@
 import org.gvsig.fmap.dal.DataStoreParameters;
 import org.gvsig.fmap.dal.exception.CloseException;
 import org.gvsig.fmap.dal.exception.InitializeException;
-import org.gvsig.fmap.dal.raster.api.BandQuery;
-import org.gvsig.fmap.dal.raster.api.RasterQuery;
+import org.gvsig.fmap.dal.raster.BandQuery;
+import org.gvsig.fmap.dal.raster.RasterQuery;
 import org.gvsig.fmap.dal.raster.spi.AbstractOpenRasterStoreParameters;
 import org.gvsig.fmap.dal.raster.spi.AbstractRasterStoreProvider;
 import org.gvsig.fmap.dal.raster.spi.BandDescriptorServices;
Index: branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.spi/src/main/java/org/gvsig/fmap/dal/raster/spi/RasterStoreProvider.java
===================================================================
--- branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.spi/src/main/java/org/gvsig/fmap/dal/raster/spi/RasterStoreProvider.java	(revision 43875)
+++ branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.spi/src/main/java/org/gvsig/fmap/dal/raster/spi/RasterStoreProvider.java	(revision 43876)
@@ -26,9 +26,9 @@
 
 import org.gvsig.fmap.dal.DataStoreParameters;
 import org.gvsig.fmap.dal.exception.InitializeException;
-import org.gvsig.fmap.dal.raster.api.BandAttributeDescriptor;
-import org.gvsig.fmap.dal.raster.api.BandDescriptor;
-import org.gvsig.fmap.dal.raster.api.RasterQuery;
+import org.gvsig.fmap.dal.raster.BandAttributeDescriptor;
+import org.gvsig.fmap.dal.raster.BandDescriptor;
+import org.gvsig.fmap.dal.raster.RasterQuery;
 import org.gvsig.fmap.dal.spi.DataStoreProvider;
 import org.gvsig.raster.lib.buffer.api.BandInfo;
 import org.gvsig.raster.lib.buffer.api.Buffer;
Index: branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/.directory
===================================================================
--- branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/.directory	(revision 0)
+++ branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/.directory	(revision 43876)
@@ -0,0 +1,4 @@
+[Dolphin]
+Timestamp=2018,6,19,10,5,57
+Version=3
+ViewMode=1
Index: branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.bsq/src/main/java/org/gvsig/fmap/dal/file/bsq/BSQLibrary.java
===================================================================
--- branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.bsq/src/main/java/org/gvsig/fmap/dal/file/bsq/BSQLibrary.java	(revision 43875)
+++ branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.bsq/src/main/java/org/gvsig/fmap/dal/file/bsq/BSQLibrary.java	(revision 43876)
@@ -94,8 +94,7 @@
                     new BSQFileSystemServerProviderFactory(
                             NAME,
                             DESCRIPTION,
-                            FILE_EXTENSIONS,
-                            true
+                            FILE_EXTENSIONS
                     )
             );
         } catch (Exception e) {
Index: branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.bsq/src/main/java/org/gvsig/fmap/dal/file/bsq/AbstractFileRasterStoreProvider.java
===================================================================
--- branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.bsq/src/main/java/org/gvsig/fmap/dal/file/bsq/AbstractFileRasterStoreProvider.java	(revision 43875)
+++ branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.bsq/src/main/java/org/gvsig/fmap/dal/file/bsq/AbstractFileRasterStoreProvider.java	(revision 43876)
@@ -8,6 +8,10 @@
 import java.util.Map;
 import org.apache.commons.io.FilenameUtils;
 import org.cresques.cts.IProjection;
+import org.gvsig.basicformats.FormatsFile;
+import org.gvsig.basicformats.PRJFile;
+import org.gvsig.basicformats.STXFile;
+import org.gvsig.basicformats.WLDFile;
 import org.gvsig.fmap.dal.DALLocator;
 import org.gvsig.fmap.dal.DataManager;
 import org.gvsig.fmap.dal.DataServerExplorer;
@@ -19,14 +23,9 @@
 import org.gvsig.fmap.dal.exception.OpenException;
 import org.gvsig.fmap.dal.exception.ReadException;
 import org.gvsig.fmap.dal.exception.ValidateDataParametersException;
-import org.gvsig.fmap.dal.fileutils.CLRFile;
-import org.gvsig.fmap.dal.fileutils.PRJFile;
-import org.gvsig.fmap.dal.fileutils.STXFile;
-import org.gvsig.fmap.dal.fileutils.WLDFile;
-import org.gvsig.fmap.dal.fileutils.spi.UtilsFile;
 import org.gvsig.fmap.dal.raster.OpenRasterStoreParameters;
-import org.gvsig.fmap.dal.raster.api.BandQuery;
-import org.gvsig.fmap.dal.raster.api.RasterQuery;
+import org.gvsig.fmap.dal.raster.BandQuery;
+import org.gvsig.fmap.dal.raster.RasterQuery;
 import org.gvsig.fmap.dal.raster.spi.AbstractAwtRasterStoreProvider;
 import org.gvsig.fmap.dal.raster.spi.AbstractRasterStoreProvider;
 import org.gvsig.fmap.dal.resource.file.FileResource;
@@ -97,9 +96,9 @@
                 new NullPointerException(this.storeProviderName +" file is null"));
         }
 
-        this.wldFile = UtilsFile.createWLDFile(this.getFile());
-        this.prjFile = UtilsFile.createPRJFile(this.getFile());
-        this.stxFile = UtilsFile.createSTXFile(this.getFile());
+        this.wldFile = FormatsFile.getWLDFile(this.getFile());
+        this.prjFile = FormatsFile.getPRJFile(this.getFile());
+        this.stxFile = FormatsFile.getSTXFile(this.getFile());
         // this.clrFile = UtilsFile.createCLRFile(this.getFile());
 
         this.projection = (IProjection) params.getDynValue(DataStore.METADATA_CRS);
Index: branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.bsq/src/main/java/org/gvsig/fmap/dal/file/bsq/BSQFileSystemServerProvider.java
===================================================================
--- branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.bsq/src/main/java/org/gvsig/fmap/dal/file/bsq/BSQFileSystemServerProvider.java	(revision 43875)
+++ branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.bsq/src/main/java/org/gvsig/fmap/dal/file/bsq/BSQFileSystemServerProvider.java	(revision 43876)
@@ -22,42 +22,44 @@
  */
 package org.gvsig.fmap.dal.file.bsq;
 
+import java.io.DataOutputStream;
 import java.io.File;
+import java.io.FileOutputStream;
+import java.io.IOException;
+import java.nio.ByteOrder;
 import org.apache.commons.io.FilenameUtils;
+import org.apache.commons.io.IOUtils;
+import org.gvsig.basicformats.FormatsFile;
+import org.gvsig.basicformats.HDRFile;
 
 import org.gvsig.fmap.dal.DataServerExplorer;
 import org.gvsig.fmap.dal.NewDataStoreParameters;
 import org.gvsig.fmap.dal.exception.CreateException;
 import org.gvsig.fmap.dal.exception.DataException;
+import org.gvsig.fmap.dal.raster.NewRasterStoreParameters;
+import org.gvsig.fmap.dal.serverexplorer.filesystem.FilesystemStoreParameters;
 import org.gvsig.fmap.dal.serverexplorer.filesystem.impl.AbstractFilesystemServerExplorerProvider;
+import org.gvsig.raster.lib.buffer.api.Band;
+import org.gvsig.raster.lib.buffer.api.Buffer;
+import org.gvsig.raster.lib.buffer.api.BufferDimensions;
+import org.gvsig.raster.lib.buffer.api.BufferManager;
 
 public class BSQFileSystemServerProvider extends AbstractFilesystemServerExplorerProvider {
 
     protected String[] fileExtensions;
-    protected boolean canCreate;
 
     public BSQFileSystemServerProvider(
-            String name, 
-            String description, 
+            String name,
+            String description,
             String[] fileExtensions
-        ) {
-        this(name, description, fileExtensions, false);
-    }
-    
-    public BSQFileSystemServerProvider(
-            String name, 
-            String description, 
-            String[] fileExtensions,
-            boolean canCreate
-        ) {
+    ) {
         super(name, description);
         this.fileExtensions = fileExtensions;
-        this.canCreate = canCreate;
     }
-    
+
     @Override
     public boolean canCreate() {
-        return canCreate;
+        return true;
     }
 
     @Override
@@ -67,9 +69,81 @@
 
     @Override
     public void create(NewDataStoreParameters parameters, boolean overwrite) throws CreateException {
-        throw new UnsupportedOperationException();
+        FileOutputStream fos = null;
+        try {
+            Buffer buffer = ((NewRasterStoreParameters) parameters).getBuffer();
+            if (!buffer.areAllBandsOfTheSameType()) {
+                throw new IllegalArgumentException("The BSQ format does not support bands of different types.");
+            }
+            BufferDimensions dimensions = buffer.getDimensions();
+            File file = ((FilesystemStoreParameters) parameters).getFile();
+            fos = new FileOutputStream(file);
+            DataOutputStream dos = new DataOutputStream(fos);
+            HDRFile hdr = FormatsFile.createHDRFile();
+            hdr.setDataType(buffer.getBandTypes()[0]);
+            hdr.setNBands(buffer.getBandCount());
+            hdr.setByteOrder(ByteOrder.nativeOrder());
+            hdr.setDimensions(
+                    dimensions.getRows(),
+                    dimensions.getColumns(),
+                    dimensions.getEnvelope()
+            );
+            for (int nband = 0; nband < buffer.getBandCount(); nband++) {
+                writeBand(dos, buffer.getBand(nband));
+            }
+            hdr.write(file);
+        } catch (Exception ex) {
+            throw new CreateException(this.getName(), ex);
+        } finally {
+            IOUtils.closeQuietly(fos);
+        }
     }
-        
+
+    void writeBand(DataOutputStream dos, Band band) throws IOException {
+        int dataType = band.getDataType();
+        Object rowBuffer = band.createRowBuffer();
+        for (int row = 0; row < band.getRows(); row++) {
+            band.fetchRow(row, rowBuffer);
+            switch (dataType) {
+                case BufferManager.TYPE_BYTE:
+                    byte[] byteBuffer = (byte[]) rowBuffer;
+                    for (int n = 0; n < byteBuffer.length; n++) {
+                        dos.writeByte(byteBuffer[n]);
+                    }
+                    break;
+                case BufferManager.TYPE_SHORT:
+                case BufferManager.TYPE_USHORT:
+                    short[] shortBuffer = (short[]) rowBuffer;
+                    for (int n = 0; n < shortBuffer.length; n++) {
+                        dos.writeShort(shortBuffer[n]);
+                    }
+                    break;
+                case BufferManager.TYPE_INT:
+                    int[] intBuffer = (int[]) rowBuffer;
+                    for (int n = 0; n < intBuffer.length; n++) {
+                        dos.writeInt(intBuffer[n]);
+                    }
+                    break;
+                case BufferManager.TYPE_FLOAT:
+                    float[] floatBuffer = (float[]) rowBuffer;
+                    for (int n = 0; n < floatBuffer.length; n++) {
+                        dos.writeFloat(floatBuffer[n]);
+                    }
+                    break;
+
+                case BufferManager.TYPE_DOUBLE:
+                    double[] doubleBuffer = (double[]) rowBuffer;
+                    for (int n = 0; n < doubleBuffer.length; n++) {
+                        dos.writeDouble(doubleBuffer[n]);
+                    }
+                    break;
+
+                default:
+                    throw new IllegalArgumentException("Data Type " + dataType + " not supported.");
+            }
+        }
+    }
+
     @Override
     public int getMode() {
         return DataServerExplorer.MODE_RASTER;
